//+------------------------------------------------------------------+
//|                                                  TrendRSI_v3.mq4 |
//|                          Typical RSI revised By TrendLaboratory  |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//|                    mrtools modified the original rsi calculation |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Silver
#property indicator_color2 LightBlue
#property indicator_color3 Tomato

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    RSIPeriod   = 14;
extern int    Price       = 0;
extern int    EMAPeriod   = 5;
extern int    ATRPeriod   = 14;
extern double K           = 2.618;
extern bool   DotsOnFirst = false;

extern double levelOb     = 70;
extern double levelOs     = 30;

//
//
//
//
//

double RSIindex[];
double UpTrend[];
double DnTrend[];
double rsi[];
double smin[];
double smax[];
double trend[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
  {
   IndicatorBuffers(7);
   SetIndexBuffer(0,RSIindex);                                                  SetIndexLabel(0,"TrendRSI");
   SetIndexBuffer(1,UpTrend); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);SetIndexLabel(1,"UpTrend"); 
   SetIndexBuffer(2,DnTrend); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);SetIndexLabel(2,"DownTrend"); 
   SetIndexBuffer(3,rsi);
   SetIndexBuffer(4,smin);
   SetIndexBuffer(5,smax);
   SetIndexBuffer(6,trend);
   
       //
       //
       //
       //
       //
         
        timeFrame         = stringToTimeFrame(TimeFrame);
        indicatorFileName = WindowExpertName();
        returnBars        = TimeFrame=="returnBars";       if (returnBars)     return(0);
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);

       //
       //
       //
       //   
       //
          
   SetLevelValue(0,levelOb);
   SetLevelValue(1,levelOs);
   IndicatorShortName(timeFrameToString(timeFrame)+"  TrendRSI ("+RSIPeriod+","+EMAPeriod+","+ATRPeriod+","+DoubleToStr(K,3)+")");
  return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { RSIindex[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     for (i=limit; i>=0; i--) rsi[i] = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price,i),RSIPeriod,i);
     for (i=limit; i>=0; i--)
     {  
        RSIindex[i] = RSIindex[i+1]+2.0/(1.0+EMAPeriod)*(rsi[i]-RSIindex[i+1]);
        double AvgRange = 0; for (int k=0; k<ATRPeriod-1; k++) AvgRange += MathAbs(RSIindex[i+k]-RSIindex[i+k+1]); 
        double range    = AvgRange/ATRPeriod;
	     smax[i]    = RSIindex[i]+K*range; 
	     smin[i]    = RSIindex[i]-K*range;
		  UpTrend[i] = EMPTY_VALUE;
        DnTrend[i] = EMPTY_VALUE;
	     trend[i]   = trend[i+1]; 
	   
	     //
	     //
	     //
	     //
	     //
	   
	     if (RSIindex[i]>smax[i+1]) trend[i] = 1; 
	     if (RSIindex[i]<smin[i+1]) trend[i] =-1;

        if (trend[i]>0 && smin[i]<smin[i+1]) smin[i] = smin[i+1];
        if (trend[i]<0 && smax[i]>smax[i+1]) smax[i] = smax[i+1];
        if (trend[i] == 1) UpTrend[i] = smin[i]; 
	     if (trend[i] ==-1) DnTrend[i] = smax[i]; 
     }
     return(0);
   }
   
   //
   //
   //
   //
   //
   
   int displace = -1; if (DotsOnFirst) displace = 1;
     limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
     for (i=limit;i>=0; i--)
     {
        int y = iBarShift(NULL,timeFrame,Time[i]);
        int x = iBarShift(NULL,timeFrame,Time[i+displace]);
         RSIindex[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSIPeriod,Price,EMAPeriod,ATRPeriod,K,0,y);
         if (x!=y)
         {          
            UpTrend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSIPeriod,Price,EMAPeriod,ATRPeriod,K,1,y);
            DnTrend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSIPeriod,Price,EMAPeriod,ATRPeriod,K,2,y);
         }
         else
         {
            UpTrend[i] = EMPTY_VALUE;
            DnTrend[i] = EMPTY_VALUE;
         }
            
   }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

       
         
//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}